(* This file was originally generated by why.
   It can be modified; only the generated parts will be overwritten. *)

Require Export caduceus_why. Require Export caduceus_tactics.

(*Why logic*) Definition lpath :
  alloc_table -> ((memory) pointer) -> pointer -> plist -> pointer -> Prop.
Admitted.

(*Why logic*) Definition cons : pointer -> plist -> plist.
Admitted.

(*Why axiom*) Lemma Path_cons :
  (forall (alloc:alloc_table),
   (forall (tl:((memory) pointer)),
    (forall (p1:pointer),
     (forall (l:plist),
      (forall (p2:pointer),
       ((valid alloc p1) /\ (lpath alloc tl (acc tl p1) l p2) <->
        (lpath alloc tl p1 (cons p1 l) p2))))))).
Admitted.

(*Why logic*) Definition nil : plist.
Admitted.

Admitted.

Admitted.

(*Why axiom*) Lemma Path_null_ax :
  (forall (alloc:alloc_table),
   (forall (tl:((memory) pointer)),
    (forall (p:pointer), (lpath alloc tl p nil p)))).
Admitted.

(*Why axiom*) Lemma Path_null_inv_ax :
  (forall (alloc:alloc_table),
   (forall (tl:((memory) pointer)),
    (forall (p:pointer),
     (forall (l:plist), ((lpath alloc tl p l p) -> l = nil))))).
Admitted.

(*Why logic*) Definition app : plist -> plist -> plist.
Admitted.

Admitted.

(*Why axiom*) Lemma app_nil_1_ax : (forall (l:plist), l = (app l nil)).
Admitted.

(*Why axiom*) Lemma app_nil_2_ax : (forall (l:plist), l = (app nil l)).
Admitted.

(*Why logic*) Definition cyclic :
  alloc_table -> ((memory) pointer) -> pointer -> Prop.
Admitted.


(*Why*) Parameter cyclic_parameter :
  forall (l: pointer), forall (alloc: alloc_table),
  forall (tl: ((memory) pointer)), forall (H: (valid alloc l)),
  (sig_1 Z (fun (result: Z)  => ((result <> 0 <-> (cyclic alloc tl l))))).

(*Why logic*) Definition disjoint : plist -> plist -> Prop.
Admitted.

(*Why axiom*) Lemma disjoint_nil1 : (forall (l:plist), (disjoint l nil)).
Admitted.

(*Why axiom*) Lemma disjoint_nil2 : (forall (l:plist), (disjoint nil l)).
Admitted.

(*Why logic*) Definition is_list :
  alloc_table -> ((memory) pointer) -> pointer -> Prop.
Admitted.

(*Why predicate*) Definition llist  (alloc:alloc_table)
  (tl:((memory) pointer)) (p:pointer) (l:plist) := (lpath alloc tl p l null).

(*Why axiom*) Lemma is_list_llist_ax :
  (forall (alloc:alloc_table),
   (forall (tl:((memory) pointer)),
    (forall (p:pointer),
     ((is_list alloc tl p) <-> (exists l:plist, (llist alloc tl p l)))))).
Admitted.

(*Why logic*) Definition length :
  alloc_table -> ((memory) pointer) -> pointer -> Length.
Admitted.

(*Why axiom*) Lemma llist_function_ax :
  (forall (alloc:alloc_table),
   (forall (tl:((memory) pointer)),
    (forall (l1:plist),
     (forall (l2:plist),
      (forall (p:pointer),
       ((llist alloc tl p l1) -> ((llist alloc tl p l2) -> l1 = l2))))))).
Admitted.

(*Why axiom*) Lemma llist_valid :
  (forall (alloc:alloc_table),
   (forall (tl:((memory) pointer)),
    (forall (p1:pointer),
     (forall (l:plist),
      ((llist alloc tl p1 l) -> (~(p1 = null) -> (valid alloc p1))))))).
Admitted.

(*Why logic*) Definition rev : plist -> plist.
Admitted.

(*Why axiom*) Lemma rev_nil_ax : (rev nil) = nil.
Admitted.


Admitted.


